# Functions for execution of Java wrapper scripts

# Some initializations:
[ "$DESTDIR" ] || DESTDIR=
[ "$JAVA_CLASSPATH" ] || JAVA_CLASSPATH=


# Use JAVACMD if it is set.  If not, check JAVA_HOME, and fall back to
# 'java' if both are unset.

java_show_debug() {
    if [ "$DEBUG" ]; then
	echo "[debug] $0: $@" >&2;
    fi
}


# Try to find a Java runtime and set JAVA_HOME and JAVACMD accordingly.
# If JAVACMD exists, nothing is done. If JAVA_HOME exists, only that
# is searched.
#
# In the other cases, the runtime is looked for according to one of the
# following arguments:
#  * 2 : java runtime 2 
#  * swing : a JVM that has swing
#  * fullxml: a JVM that has all XML classes, including
#    javax.xml.stream.util.StreamReaderDelegate
#
# If JAVA_DEBUG is set, we try to use jdb rather than java, if it is
# present.
#
# This information is currently *far from complete* !!!
find_java_runtime() {
    # First, some variables
    sun_java="/usr/lib/jvm/java-6-sun /usr/lib/jvm/java-1.5.0-sun /usr/lib/j2sdk1.4-sun " 
    gcj2="/usr/lib/jvm/java-*-gcj-4.* "
    icedtea="/usr/lib/jvm/java-6-openjdk"
    if [ "$JAVACMD" ]; then
	java_show_debug "Using already set JAVACMD = $JAVACMD"
	return 0;		# Nothing to do
    fi

    if [ -z "$JAVA_HOME" ]; then
        # We now try to look for a reasonable JAVA_HOME.
        # First, narrow the choices, approximately according to what
        # was asked
	case $1 in
	    2) DIRS="$icedtea $gcj2 $sun_java";
		;;
	    # So far, only Sun and IcedTea have swing...
	    swing) DIRS="$icedtea $sun_java";
		;;
	    sun) DIRS="$sun_java" # To make sure only sun is found...
		;;
	    xml) DIRS="$icedtea /usr/lib/jvm/java-6-sun ";
		;;
	    *) DIRS=/usr/lib/jvm/*
		DIRS="$DIRS /usr/lib/kaffe"
		;;
	esac
        # And pick up the first one that works
	for dir in $DIRS; do
	    if [ -x $dir/bin/java ]; then
		JAVA_HOME=$dir
		break;
	    fi
	done
    fi
    if [ "$JAVA_HOME" ] ; then
	if [ "$JAVA_DEBUG" ] && [ -x "$JAVA_HOME/bin/jdb" ]; then
	    JAVACMD="$JAVA_HOME/bin/jdb"
	else
	    JAVACMD="$JAVA_HOME/bin/java"
	fi
	java_show_debug "Found JAVA_HOME = $JAVA_HOME"
	java_show_debug "Found JAVACMD = $JAVACMD"
	return 0		# Fine
    else
	exit 1;
    fi

}

# Find jars and add them to the classpath
find_jars() {
    for jar in $@ ; do
	if [ -r $DESTDIR/usr/share/java/$jar ]; then
	    JAVA_CLASSPATH=$JAVA_CLASSPATH:$DESTDIR/usr/share/java/$jar
	elif [ -r $DESTDIR/usr/share/java/$jar.jar ]; then 
	    JAVA_CLASSPATH=$JAVA_CLASSPATH:$DESTDIR/usr/share/java/$jar.jar
	else
	    echo "error: Unable to locate $jar in $DESTDIR/usr/share/java/" >&2
	fi
    done
}

# Runs the program !
run_java() {
    if [ "$JAVA_CLASSPATH" ]; then
	cp="-cp $JAVA_CLASSPATH";
    else
	cp="";
    fi
    java_show_debug "Runnning $JAVACMD $JAVA_ARGS $cp $@"
    exec $JAVACMD $JAVA_ARGS $cp "$@"
}
